## mingw-w64-libnegf-1.1.3-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)
include(LibNegfUtils)
libnegf_load_build_settings()

project(libNEGF VERSION 1.1.2 LANGUAGES Fortran C)

# Some setting output 
message(STATUS "libNEGF WITH_MPI: " ${WITH_MPI})
message(STATUS "libNEGF WITH_INELASTIC: " ${WITH_INELASTIC})

include(externalMpifx)
include(CMakePackageConfigHelpers)

set(CMAKE_PREFIX_PATH "${CMAKE_CURRENT_SOURCE_DIR}/ext_fypp/;${CMAKE_PREFIX_PATH}")
find_program(FYPP "fypp")

include(GNUInstallDirs)


if(LAPACK_LIBRARIES AND LAPACK_LIBRARY_DIRS)
  message(STATUS "libNEGF LAPACK DIR: " ${LAPACK_LIBRARY_DIRS})
  message(STATUS "libNEGF BLAS: " ${BLAS_LIBRARIES})
  message(STATUS "libNEGF LAPACK: " ${LAPACK_LIBRARIES})
else()
  message(STATUS "libNEGF MKLROOT: " $ENV{MKLROOT})
  find_package(CustomBlas REQUIRED)
  find_package(CustomLapack REQUIRED)
  #message(STATUS "libNEGF BLAS found: " ${BLAS_LIBRARIES})
  #message(STATUS "libNEGF LAPACK found: " ${LAPACK_LIBRARIES})
  #message(STATUS "libNEGF LAPACK DIR: " ${LAPACK_LIBRARY_DIRS})
endif()

if(WITH_MPI)
  find_package(MPI REQUIRED)
  find_or_fetch_mpifx()
endif()

if(WITH_OMP)
  find_package(OpenMP REQUIRED)
endif()

# Subdirectories.
add_subdirectory(ext_system)
add_subdirectory(src)
add_subdirectory(src/api)
add_subdirectory(src/sparskit)
if(BUILD_TESTING)
  enable_testing()
  add_subdirectory(tests)
endif()


#
# Installation
#
set(CMAKE_INSTALL_PREFIX "/usr/local/libnegf${libNEGF_VERSION_MAJOR}.${libNEGF_VERSION_MINOR}" CACHE PATH
	"default installation path")

message(STATUS "Default installation path: " ${CMAKE_INSTALL_PREFIX})

add_library(Negf INTERFACE)
target_link_libraries(Negf INTERFACE negf)
install(TARGETS Negf EXPORT negf-targets)

install(EXPORT negf-targets
  FILE negf-targets.cmake
  NAMESPACE Negf::
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/negf"
  EXPORT_LINK_INTERFACE_LIBRARIES)

configure_package_config_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/utils/export/negf-config.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/cmake/negf-config.cmake
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/negf)

write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/cmake/negf-config-version.cmake
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY SameMajorVersion)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/cmake/negf-config.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/cmake/negf-config-version.cmake
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/negf)

=== Makefile ===
ROOT = $(shell pwd)

ARCH1= $(shell uname -m)
ARCH = $(ARCH1)-linux-mpich-gfortran

DEBUG=0

MPI=Y

INELASTIC=

OBJDIR= _objdir

include ./sysmakes/make.$(ARCH)

include Makefile.lib

=== ext_fftw/Makefile ===

VER=3.3.5

all: install 

.PHONY: install 

DIR=$(shell pwd)

install: _COMPILE_ 
	make install prefix=$(DIR)  -C fftw-$(VER)
	#rm -f _UNTAR_ _CONFIGURE_ _COMPILE_
	
_COMPILE_: _CONFIGURE_ 
	make -C fftw-$(VER) 
	touch _COMPILE_ 

_CONFIGURE_: _UNTAR_
	cd fftw-$(VER); ./configure F77=$(FC)
	touch _CONFIGURE_
	
_UNTAR_: fftw-$(VER).tar 
	tar -xvf fftw-$(VER).tar
	touch _UNTAR_

fftw-$(VER).tar: 
	wget fftw.org/fftw-$(VER).tar.gz
	gunzip fftw-$(VER).tar.gz

distclean:
	rm -rf fftw-$(VER)* lib include bin shared

=== ext_system/CMakeLists.txt ===
set(sources
  sys_calls.c
  system_calls.f90)

add_library(syscalls_objlib OBJECT ${sources})

set(BUILD_MOD_DIR ${CMAKE_CURRENT_BINARY_DIR}/include)

set_target_properties(syscalls_objlib PROPERTIES Fortran_MODULE_DIRECTORY ${BUILD_MOD_DIR})
set_target_properties(syscalls_objlib PROPERTIES POSITION_INDEPENDENT_CODE ${BUILD_SHARED_LIBS})

target_include_directories(syscalls_objlib PUBLIC
  $<BUILD_INTERFACE:${BUILD_MOD_DIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${INSTALL_MOD_DIR}>)

if(INSTALL_INCLUDE_FILES)
  install(DIRECTORY ${BUILD_MOD_DIR}/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${INSTALL_MOD_DIR})
endif()

=== mpi_include/Makefile ===

all:
	$(FC) -c mpi.f90

clean:
	rm -rf *.mod *.o

=== src/CMakeLists.txt ===
set(sources-fpp
  clock.F90
  ln_extract.F90
  complexbands.F90
  input_output.F90
  ln_cache.F90
  lib_param.F90
  elph.F90
  phph.F90
  ln_precision.F90
  mpi_globals.F90
  contselfenergy.F90
  inversions.F90
  libnegf.F90
  ln_structure.F90
  outmatrix.F90
  rcm_module.F90
  distributions.F90
  ln_allocation.F90
  load.F90
  sparsekit_drv.F90
  integrations.F90
  globals.F90
  iterative.F90
  ln_constants.F90
  mat_def.F90
  population.F90
  energy_mesh.F90
  interactions.F90
  elphdd.F90
  elphdb.F90
  elphds.F90
  sparskit/skit_blassm.F90
  sparskit/skit_formats.F90
  sparskit/skit_module.F90
  sparskit/skit_unary.F90)

if(WITH_INELASTIC)
  list(APPEND sources-fpp transform.F90)
endif()

set(sources-f90
  api/libnegfAPICommon.f90
  api/libnegf_api.f90)

#execute_process(COMMAND git describe OUTPUT_VARIABLE gitrevision)
set(gitrevision "000")
string(TIMESTAMP compdate "%Y-%m-%d")

set(fyppdefs -D_GITREVISION=\"${gitrevision}\" -D_COMPDATE=\"${compdate}\")
if(WITH_MPI)
  list(APPEND fyppdefs -DMPI)
endif()

set(sources-fpp-f90)
foreach(fppsrc IN LISTS sources-fpp)
  string(REGEX REPLACE "\\.F90" ".f90" f90src ${fppsrc})
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${f90src}
    COMMAND ${FYPP} ${fyppdefs} ${CMAKE_CURRENT_SOURCE_DIR}/${fppsrc}
      ${CMAKE_CURRENT_BINARY_DIR}/${f90src}
    MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/${fppsrc}
    VERBATIM)
  list(APPEND sources-fpp-f90 ${CMAKE_CURRENT_BINARY_DIR}/${f90src})
endforeach()

#add_library(negf ${sources-fpp-f90} ${sources-f90} $<TARGET_OBJECTS:sparskit_objlib>)
add_library(negf ${sources-fpp-f90} ${sources-f90})

target_sources(negf PRIVATE $<TARGET_OBJECTS:syscalls_objlib>)
target_include_directories(negf PUBLIC
  $<BUILD_INTERFACE:$<TARGET_PROPERTY:syscalls_objlib,INTERFACE_INCLUDE_DIRECTORIES>>)

set(BUILD_MOD_DIR ${CMAKE_CURRENT_BINARY_DIR}/include)

set_target_properties(negf PROPERTIES Fortran_MODULE_DIRECTORY ${BUILD_MOD_DIR})

if(WITH_MPI)
  find_package(MPI REQUIRED)
  target_link_libraries(negf PUBLIC MpiFx::MpiFx MPI::MPI_Fortran)
endif()
target_link_libraries(negf PRIVATE ${BLAS_LIBRARIES} ${LAPACK_LIBRARIES})

target_include_directories(negf PUBLIC
  $<BUILD_INTERFACE:${BUILD_MOD_DIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${INSTALL_MOD_DIR}>)

install(TARGETS negf
  EXPORT negf-targets
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

if(INSTALL_INCLUDE_FILES)
  install(DIRECTORY ${BUILD_MOD_DIR}/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${INSTALL_MOD_DIR})
endif()

=== src/api/CMakeLists.txt ===
set(negf-interface-headers)
set(all-header-deps libnegf_api.f90 bind_fortran)

add_custom_target(negf-c-binding ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/libnegf.h)
set(c-header-binding-deps binding/map_negf_c.txt binding/begin_c.txt binding/end_c.txt)
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/libnegf.h
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${all-header-deps} ${CMAKE_CURRENT_SOURCE_DIR}/${c-header-binding-deps}
    COMMENT "Generating C header"
    COMMAND ./bind_fortran -f c -m binding/map_negf_c.txt -b binding/begin_c.txt -n -t -e binding/end_c.txt libnegf_api.f90 > ${CMAKE_CURRENT_BINARY_DIR}/libnegf.h
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)
list(APPEND negf-interface-headers ${CMAKE_CURRENT_BINARY_DIR}/libnegf.h)

add_custom_target(negf-cpp-binding ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/libnegf.hpp)
set(cpp-header-binding-deps binding/map_negf_cpp_wrapped.txt binding/begin_cpp_wrapped.txt binding/end_cpp_wrapped.txt)
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/libnegf.hpp
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${all-header-deps} ${CMAKE_CURRENT_SOURCE_DIR}/${cpp-header-binding-deps}
    COMMENT "Generating C++ header"
    COMMAND ./bind_fortran -f c++ -m binding/map_negf_cpp_wrapped.txt -b binding/begin_cpp_wrapped.txt -t -e binding/end_cpp_wrapped.txt libnegf_api.f90 > ${CMAKE_CURRENT_BINARY_DIR}/libnegf.hpp
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)
list(APPEND negf-interface-headers ${CMAKE_CURRENT_BINARY_DIR}/libnegf.hpp)

add_custom_target(negf-all-headers ALL DEPENDS negf-c-binding negf-cpp-binding ${CMAKE_CURRENT_BINARY_DIR}/lnParams.h)
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/lnParams.h
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/lnParams.h
    COMMENT "Copying lnParams.h"
    COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/lnParams.h ${CMAKE_CURRENT_BINARY_DIR}/lnParams.h
)
list(APPEND negf-interface-headers ${CMAKE_CURRENT_BINARY_DIR}/lnParams.h)

if(INSTALL_INCLUDE_FILES)
    install(FILES ${negf-interface-headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
endif()

=== src/tests/Makefile ===
#########################################################################
#                          libNEGF Makefile
#
#
#########################################################################
include ../../Makefile.user

FC90 = ifort
CC = gcc
FPP = fpp
LIBNEGFSRC=$(shell pwd)
SPARSEKITDIR=../ext_sparskit
FC = $(FC90)
FC90OPT = -g -check all
#FC90OPT = -O2 -xW -openmp -ip
CFLAGS = $(CCOPT)
F77FLAGS = $(FC90OPT)
FPPFLAGS = -D__PARDISO
LINKFLAG = -openmp

TARGET_BASE = libnegf

ARCH = $(shell uname -m)-linux-ifort

METIS_DIR = ../../ext_metis/metis-4.0
LIB_METIS = $(METIS_DIR)/libmetis.a

SPARSEKIT = ../../ext_sparskit/zlibskit.x86_64-linux-ifort.a

#########################################################################


ifdef MPI
        FPP = fpp -DMPI
        FC = $(MPI_DIR)/mpif90 -f90=$(FC90)
        TARGET	= $(TARGET_BASE)_mpi.a
else
        FPP = fpp
        FC = $(FC90)
        TARGET	= $(TARGET_BASE).$(ARCH).a
endif

LIBNEGF = ../$(TARGET)
LIBS = $(SPARSEKIT) $(LIB_METIS) -L$(MKL_LIBDIR) $(LIB_BLAS)

######################################################################
# Explicit rules
######################################################################

.SUFFIXES :
.SUFFIXES : .c .o .f90 .F90

.f.o:
	$(FC) $(F77FLAGS) -c $*.f

.F90.o:
	@$(FPP) $(FPPFLAGS) $*.F90 > $*.f90
	$(FC90) $(FC90OPT) -c $*.f90
	\rm -f $*.f90

.c.o:
	$(CC) $(CFLAGS) -c readpar.c -o readpar.o

######################################################################
# The real stuff
######################################################################

#all: test1 testdos testint test2 testreorder testiterativedns \
#       	testcontactdos testcurrent testdosdns testneqint

OBJECTS = mpi_globals.o ln_constants.o ln_precision.o ln_allocation.o \
contselfenergy.o population.o \
mat_def.o clock.o fermi.o iterative.o complexbands.o lowdin.o \
sparsekit_drv.o ln_structure.o inversions.o outmatrix.o \
input_output.o lib_param.o libnegf.o globals.o \
rcm_module.o iterative_dns.o ln_extract.o

FC90OPT += -I..

MODULES = #$(OBJECTS:.o=.mod)

#$(MODULES): $(LIBNEGF)
	#(cp -f ../*.mod .)

$(LIBNEGF):
	($(MAKE) -C ..)

testdos: Testdos.F90 $(LIBNEGF) $(MODULES)
	$(FC90) $(FC90OPT) -c Testdos.F90
	$(FC)  $(LINKFLAG) -o $@  Testdos.o $(LIBNEGF) $(LIBS)

testint: Testint.F90 $(LIBNEGF) $(MODULES)
	$(FC90) $(FC90OPT) -c Testint.F90
	$(FC) $(LINKFLAG) -o $@  Testint.o $(LIBNEGF) $(LIBS)

test2: test2.F90 $(LIBNEGF) $(MODULES)
	$(FC90) $(FC90OPT) -c test2.F90
	$(FC) $(LINKFLAG) -o $@  test2.o $(LIBNEGF) $(LIBS)

testreorder: testreorder.F90 $(LIBNEGF) $(MODULES)
	$(FC90) $(FC90OPT) -c testreorder.F90
	$(FC) $(LINKFLAG)  -o $@  testreorder.o $(LIBNEGF) $(LIBS)

testiterativedns: Testiterativedns.F90 $(LIBNEGF) $(MODULES)
	$(FC90) $(FC90OPT) -c Testiterativedns.F90
	$(FC) $(LINKFLAG)  -o $@  Testiterativedns.o $(LIBNEGF) $(LIBS)

testcontactdos: testcontactdos.F90 $(LIBNEGF) $(MODULES)
	$(FC90) $(FC90OPT) -c testcontactdos.F90
	$(FC) $(LINKFLAG)  -o $@  testcontactdos.o $(LIBNEGF) $(LIBS)

testdosdns: testdosdns.F90 $(LIBNEGF) $(MODULES)
	$(FC90) $(FC90OPT) -c testdosdns.F90
	$(FC) $(LINKFLAG)  -o $@  testdosdns.o $(LIBNEGF) $(LIBS)

testcurrent: testcurrent.F90 $(LIBNEGF) $(MODULES)
	$(FC90) $(FC90OPT) -c testcurrent.F90
	$(FC) $(LINKFLAG)  -o $@  testcurrent.o $(LIBNEGF) $(LIBS)

testneqint: testneqint.F90 $(LIBNEGF) $(MODULES)
	$(FC90) $(FC90OPT) -c testneqint.F90
	$(FC) $(LINKFLAG)  -o $@  testneqint.o $(LIBNEGF) $(LIBS)

testcomplex: testcomplexband.F90 $(LIBNEGF) $(MODULES)
	$(FC90) $(FC90OPT) -c testcomplexband.F90
	$(FC) $(LINKFLAG)  -o $@  testcomplexband.o $(LIBNEGF) $(LIBS)

testfermi: testfermi.F90 $(LIBNEGF) $(MODULES)
	$(FC90) $(FC90OPT) -c testfermi.F90
	$(FC) $(LINKFLAG)  -o $@  testfermi.o $(LIBNEGF) $(LIBS)

clean:
	(rm -f ifc* work* core .f90 *.mod *.o; )

=== src/unused/Makefile ===
#########################################################################
#                          libNEGF Makefile 
#
#
#########################################################################
include ../Makefile.user

TARGET_BASE = libnegf
ARCH = $(shell uname -m)-linux-ifort

#FC90 = ifort
#FC90 = gfortran-4.6.0 
FC = $(FC90)

#FC90OPT = -g -check all 
#FC90OPT = -g -fbounds-check -Wall -pedantic 
#FC90OPT = -O2 -xW -openmp -ip

CFLAGS = $(CCOPT)
F77FLAGS = $(FC90OPT)
FPPFLAGS = -D__PARDISO
LINKFLAG = -openmp

#FPPFLAGS += -D__SVNREVISION='"$(shell svn info | awk '/^Last Changed Rev/{print $$4}' )"'
#FPPFLAGS += -D__MODIFIED='"$(shell svn status | grep 'M ' | grep -m1 -o 'M ')"'
#FPPFLAGS += -D__COMPDATE='"$(shell date +'%F')"'
FPPFLAGS += -D__GITREVISION='"$(shell git describe)"'
FPPFLAGS += -D__COMPDATE='"$(shell date +'%F')"'


LIBNEGFSRC=$(shell pwd)
SPARSEKITDIR=../ext_sparskit
METIS_DIR = ../ext_metis/metis-4.0
LIB_METIS = $(METIS_DIR)/libmetis.a 

SPARSEKIT = ../ext_sparskit/zlibskit.x86_64-linux-ifort.a

LIBS = $(SPARSEKIT) $(LIB_METIS) -L$(MKL_LIBDIR) $(LIB_BLAS) 
#########################################################################


ifdef MPI
        FPP = fpp -DMPI
        FC = $(MPI_DIR)/mpif90 -f90=$(FC90) 		
        TARGET	= $(TARGET_BASE)_mpi.a
else
        FPP = fpp 
        FC = $(FC90) 
        TARGET	= $(TARGET_BASE).$(ARCH).a
endif


######################################################################
# Explicit rules
######################################################################

.SUFFIXES :
.SUFFIXES : .c .o .f90 .F90 

.f.o:
	$(FC) $(F77FLAGS) -c $*.f

.F90.o:
	@$(FPP) $(FPPFLAGS) $*.F90 > $*.f90
	$(FC90) $(FC90OPT) -c $*.f90
	\rm -f $*.f90

.c.o:
	$(CC) $(CFLAGS) -c readpar.c -o readpar.o

######################################################################
# The real stuff
######################################################################

MODULES = mpi_globals.o ln_constants.o ln_precision.o ln_allocation.o \
contselfenergy.o population.o metis_interface.o \
mat_def.o clock.o fermi.o iterative.o complexbands.o lowdin.o \
sparsekit_drv.o ln_structure.o inversions.o outmatrix.o \
input_output.o lib_param.o libnegf.o globals.o \
rcm_module.o iterative_dns.o ln_extract.o elph.o 


#########################################################################
# Main
#########################################################################


all: $(TARGET) 

tests: $(TARGET) testdos testint	
 
clean: 
	(rm -f $(TARGET) ! ifc* work* core .f90 *.mod *.o; \
	cd $(SPARSEKITDIR); make clean; cd $(LIBNEGFSRC); )


$(TARGET): $(MODULES) 
	ar -r $@ $^


$(SPARSEKITMODULES): 
	(cd $(SPARSEKITDIR); make objects ; cd $(LIBNEGFSRC)  )


######################################################################
# include deps
######################################################################
ln_allocation.o:    ln_precision.o
ln_constants.o:     ln_precision.o
#:    ln_precision.o constants.o
lib_param.o:  ln_precision.o globals.o mat_def.o ln_structure.o input_output.o elph.o
mat_def.o:       ln_allocation.o

iterative.o:     ln_allocation.o  mat_def.o sparsekit_drv.o 
iterative.o:     inversions.o ln_structure.o

iterative_dns.o: ln_allocation.o  mat_def.o sparsekit_drv.o
iterative_dns.o: inversions.o ln_structure.o

ln_extract.o: ln_precision.o ln_allocation.o mat_def.o sparsekit_drv.o
ln_extract.o: ln_structure.o lib_param.o ln_constants.o

input_output.o:  ln_precision.o ln_allocation.o mat_def.o sparsekit_drv.o 
inversions.o:    ln_allocation.o mat_def.o sparsekit_drv.o

complexbands.o:    ln_precision.o ln_constants.o inversions.o lowdin.o	

contselfenergy.o: lib_param.o ln_allocation.o mat_def.o sparsekit_drv.o 
contselfenergy.o: outmatrix.o clock.o complexbands.o mpi_globals.o
contselfenergy.o: ln_structure.o

sparsekit_drv.o:  mat_def.o ln_allocation.o

#greendftb.o: 	 constants.o lib_param.o sparsekit_drv.o iterative.o
#greendftb.o:     mat_def.o ln_structure.o contselfenergy.o clock.o fermi.o

libnegf.o:    ln_precision.o lib_param.o input_output.o ln_allocation.o ln_structure.o
libnegf.o:    sparsekit_drv.o inversions.o iterative.o rcm_module.o 
libnegf.o:     ln_extract.o contselfenergy.o iterative_dns.o

elph.o: ln_precision.o globals.o 

population.o:    ln_precision.o mat_def.o 

test1: load.o ln_structure.o 

knitting.o:  ln_precision.o ln_allocation.o mat_def.o sparsekit_drv.o inversions.o
knitting.o: supermat.o ln_structure.o

supermat.o: mat_def.o ln_allocation.o



#scattstates.o:   ln_precision.o constants.o mat_def.o sparsekit_drv.o
#scattstates.o:   ln_allocation.o contselfenergy.o complexbands.o inversions.o


######################################################################
# other make options 
######################################################################

## END ###############################################################

=== tests/f90int_file/CMakeLists.txt ===
setup_f90_test(f90int_file hello.F90)

=== tests/f90issue6/CMakeLists.txt ===
setup_f90_test(f90issue6 f90issue6.F90)

=== tests/fftmpi/Makefile ===

NEGFSRC=../../src
MPIFX=../../ext_mpifx/src
FFTW3I=../../ext_fftw/include
FFTW3L=../../ext_fftw/lib

all: 
	mpif90-3.1.1 -fc=gfortran-4.8.1 -I$(NEGFSRC) -I$(FFTW3I) -I$(MPIFX) -O2 test.f90 $(NEGFSRC)/mpi_globals.o $(NEGFSRC)/clock.o -L$(FFTW3L) -lfftw3_mpi -lfftw3 -L$(MPIFX) -lmpifx

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=libnegf
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.1.3
pkgrel=1
pkgdesc="A general library for Non Equilibrium Green's Functions. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://github.com/libnegf/libnegf'
license=('spdx:LGPL-3.0-or-later')
depends=($([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-openblas")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-omp"
             "${MINGW_PACKAGE_PREFIX}-python-fypp")
source=("https://github.com/libnegf/libnegf/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "001-fix-install-dll.patch"
        "002-fix-build-on-mingw-w64.patch")
sha256sums=('8d2a41791e459a203db4e4f3a9395804434ce2cd91b1bbb09111cffb032f237e'
            '8666c458cd9815087a59fbe84d4f2d2e599a2a6f7e312d667f86e54d5e56dffd'
            'c95d78ff11dff58051e72e7e351f013d0cc9393e8c48964cf442121222b6bee2')

prepare() {
  cd "${_realname}-${pkgver}"

  patch -Np1 -i "${srcdir}"/001-fix-install-dll.patch
  patch -Np1 -i "${srcdir}"/002-fix-build-on-mingw-w64.patch
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -DWITH_MPI=OFF \
      -DWITH_OMP=ON \
      -DBUILD_TESTING=OFF \
      -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      -DFYPP=${MINGW_PREFIX}/bin/fypp \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

check() {
  cmake -S"${_realname}-${pkgver}" -B"build-${MSYSTEM}" -DBUILD_TESTING=ON
  cmake --build "build-${MSYSTEM}"

  PATH="${srcdir}"/build-${MSYSTEM}/src:$PATH \
  ctest --test-dir "build-${MSYSTEM}" --output-on-failure || echo "Tests failed"
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    -t "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}
}
